unit hlavni;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids;
//Cisla pod kterymi jsou jednotlive polozky v tabulce
const id        =0;
      jmeno     =1;
      prijmeni  =2;
      pohlavi   =3;
      narozeni  =4;
      umrti     =5;
      matka     =6;
      otec      =7;

type
  TForm1 = class(TForm)
    Tabulka: TStringGrid;
    Vlastnosti: TGroupBox;
    label1: TLabel;
    label99: TLabel;
    deti: TListBox;
    manzel: TListBox;
    Label2: TLabel;
    Label3: TLabel;
    Lotec: TLabel;
    Lmatka: TLabel;
    GroupBox1: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    Soubor: TMemo;
    SaveDialog1: TSaveDialog;
    Button1: TButton;
    Button2: TButton;
    Label4: TLabel;
    Ljmeno: TLabel;
    Label5: TLabel;
    Lvek: TLabel;
    Label6: TLabel;
    Lpohlavi: TLabel;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    function NactiRodokmen(cesta: String): Integer;
    procedure Ulozrodokmen(cesta: String);
    procedure CistiTabulku;
    procedure FormCreate(Sender: TObject);
    procedure TabulkaSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    function PridejRodokmen(cesta: String): Integer;
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.PridejRodokmen(cesta: String): Integer;
//ALPHA verze,   nestihl sem
  var data: TStrings;
      element,obsah: String;
      radek,aktualniosoba: Integer;
      noveID: Integer;
  begin
   result:=0;
   aktualniosoba:= tabulka.Rowcount;
   soubor.Lines.LoadFromFile(cesta);
   data:=soubor.Lines;
   if Pos('<rodokmen>', data[0])=0 then
     begin
      result:=1;  //Nejde o soubor rodokmenu nebo je rodokmen prazdny <rodokmen/>
      exit;
     end;

   radek:=1;
   while (radek <= data.Count) and
         (Pos('</rodokmen>',data[radek])=0) do
    begin
     element:= Copy(data[radek], Pos('<',data[radek]), Pos('>',data[radek])-Pos('<',data[radek])+1 );
     obsah:= Copy(data[radek], Pos('>',data[radek])+1, Pos('</',data[radek])-Pos('>',data[radek])-1 );

     if element='<osoba>' then
        Inc(aktualniosoba)
     else if element='<id>' then
       begin
        noveID:= 1;
        while Tabulka.Cols[0].IndexOf('I'+ IntToStr(noveID))<>-1 do Inc(noveID);
        obsah:='I'+ IntToStr(noveID);

        Tabulka.Rows[aktualniosoba][id]:=obsah
       end
     else if element='<jmeno>' then
        Tabulka.Rows[aktualniosoba][jmeno]:=obsah
     else if element='<prijmeni>' then
        Tabulka.Rows[aktualniosoba][prijmeni]:=obsah
     else if element='<pohlavi>' then
        Tabulka.Rows[aktualniosoba][pohlavi]:=obsah
     else if element='<narozeni>' then
        Tabulka.Rows[aktualniosoba][narozeni]:=obsah
     else if element='<umrti>' then
        Tabulka.Rows[aktualniosoba][umrti]:=obsah
     else if element='<matka>' then
        Tabulka.Rows[aktualniosoba][matka]:=obsah
     else if element='<otec>' then
        Tabulka.Rows[aktualniosoba][otec]:=obsah;

     Inc(radek);
    end;

   Tabulka.RowCount:=aktualniosoba+1;

  end;


procedure TForm1.Button1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
  begin
   CistiTabulku;
   deti.Items.Clear;
   manzel.Items.Clear;
   Lotec.Caption:=' - ';
   Lmatka.Caption:=' - ';

   NactiRodokmen(OpenDialog1.FileName);
  end;
end;

procedure TForm1.CistiTabulku;
  var pocitadlo: Integer;
begin
 for pocitadlo:=0 to 8 do Tabulka.Cols[pocitadlo].Clear;
   Tabulka.Rows[0][id]      :='Id';
   Tabulka.Rows[0][jmeno]   :='Jmeno';
   Tabulka.Rows[0][prijmeni]:='Prijmeni';
   Tabulka.Rows[0][pohlavi] :='Pohlavi';
   Tabulka.Rows[0][narozeni]:='Narozeni';
   Tabulka.Rows[0][umrti]   :='Umrti';
   Tabulka.Rows[0][matka]   :='Matka';
   Tabulka.Rows[0][otec]    :='Otec';
   Tabulka.Cells[0,1]:='I1';
  end;

procedure TForm1.Ulozrodokmen(cesta: String);
var index: Integer;
 begin
 with Tabulka do
 with Soubor.Lines do
 begin
  Soubor.Clear;
  Add('<rodokmen>');

  for index:=1 to tabulka.RowCount-1 do
   begin
    Add('   <osoba>');
    Add('<id>' +Cells[0,index]+ '</id>');
    if Cells[jmeno,index]<>'' then
      Add('      <jmeno>' +Cells[jmeno,index]+ '</jmeno>') else
      Add('      <jmeno/>');
    if Cells[prijmeni,index]<>'' then
      Add('      <prijmeni>' +Cells[prijmeni,index]+ '</prijmeni>') else
      Add('      <prijmeni/>');
    if Cells[pohlavi,index]<>'' then
      Add('      <pohlavi>' +Cells[pohlavi,index]+ '</pohlavi>') else
      Add('      <pohlavi/>');
    if Cells[narozeni,index]<>'' then
      Add('      <narozeni>' +Cells[narozeni,index]+ '</narozeni>') else
      Add('      <narozeni/>');
    if Cells[umrti,index]<>'' then
      Add('      <umrti>' +Cells[umrti,index]+ '</umrti>') else
      Add('      <umrti/>');
    if Cells[matka,index]<>'' then
      Add('      <matka>' +Cells[matka,index]+ '</matka>') else
      Add('      <matka/>');
    if Cells[otec,index]<>'' then
      Add('      <otec>' +Cells[otec,index]+ '</otec>') else
      Add('      <otec/>');


    Add('   </osoba>');
   end;



  Add('</rodokmen>');
//Soubor je hotovej
 end;//with end

   Soubor.Lines.SaveToFile(cesta);
 end;

function TForm1.NactiRodokmen(cesta: String): Integer;
//Pokud vrati 0, vse probehlo v poradku
  var data: TStrings;
      element,obsah: String;
      radek,aktualniosoba: Integer;
  begin
   result:=0;
   aktualniosoba:= 0;
   soubor.Lines.LoadFromFile(cesta);
   data:=soubor.Lines;
   if Pos('<rodokmen>', data[0])=0 then
     begin
      result:=1;  //Nejde o soubor rodokmenu nebo je rodokmen prazdny <rodokmen/>
      exit;
     end;

   radek:=1;
   while (radek <= data.Count) and
         (Pos('</rodokmen>',data[radek])=0) do
    begin
     element:= Copy(data[radek], Pos('<',data[radek]), Pos('>',data[radek])-Pos('<',data[radek])+1 );
     obsah:= Copy(data[radek], Pos('>',data[radek])+1, Pos('</',data[radek])-Pos('>',data[radek])-1 );

     if element='<osoba>' then
        Inc(aktualniosoba)
     else if element='<id>' then
        Tabulka.Rows[aktualniosoba][id]:=obsah
     else if element='<jmeno>' then
        Tabulka.Rows[aktualniosoba][jmeno]:=obsah
     else if element='<prijmeni>' then
        Tabulka.Rows[aktualniosoba][prijmeni]:=obsah
     else if element='<pohlavi>' then
        Tabulka.Rows[aktualniosoba][pohlavi]:=obsah
     else if element='<narozeni>' then
        Tabulka.Rows[aktualniosoba][narozeni]:=obsah
     else if element='<umrti>' then
        Tabulka.Rows[aktualniosoba][umrti]:=obsah
     else if element='<matka>' then
        Tabulka.Rows[aktualniosoba][matka]:=obsah
     else if element='<otec>' then
        Tabulka.Rows[aktualniosoba][otec]:=obsah;

     Inc(radek);
    end;

   Tabulka.RowCount:=aktualniosoba+1;

  end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 CistiTabulku;
end;

procedure TForm1.TabulkaSelectCell(Sender: TObject; ACol, ARow: Integer;
//Obnovi pole vlastnosti pri vyrani nove osoby
  var CanSelect: Boolean);
var index: Integer;
    Aid: String; //ID zvolene osoby jejiz vlastnosti se hledaji
    indexInfo: String; //Kratke informace o prave zkoumane osobe ze seznamu ktere budou pridany do seznamu deti, rodicu...
    manzelInfo: String; //Informace o manzelovi(ce)
begin
 with tabulka do
  begin
 deti.Items.Clear;
 manzel.Items.Clear;
 Lotec.Caption:=' - ';
 Lmatka.Caption:=' - ';
 Ljmeno.Caption:=' - ';
 Lvek.Caption:=' - ';
 Lpohlavi.Caption:=' - ';

 Aid:=Cells[id,ARow];
 //Budeme vyplnovat tabulku vlastnosti zvolene osoby
 Ljmeno.Caption:= Cells[jmeno,ARow]+' '+Cells[prijmeni,ARow];
 if Cells[narozeni,ARow]<>'' then
  if Cells[umrti,ARow]<>'' then
   begin //umrel
    Lvek.Caption:='Doil(a) se '+     IntToStr( StrToIntDef(Cells[umrti,ARow],0) - StrToIntDef(Cells[narozeni,ARow],0) )+ ' let';
   end else
   begin //jeste zije
    Lvek.Caption:= IntToStr( 2002 - StrToIntDef(Cells[narozeni,ARow],0) )+ ' let';
   end;

 //Pohlavi
 if Cells[pohlavi,ARow]='M' then Lpohlavi.Caption:='Mu' else
 if Cells[pohlavi,ARow]='Z' then Lpohlavi.Caption:='ena' else
 if Cells[pohlavi,ARow]='' then Lpohlavi.Caption:='hermafrodit';

 for index:=1 to Tabulka.RowCount do
  begin
  indexInfo:= Cells[id,index] +' - '+ Cells[jmeno,index]+' '+Cells[prijmeni,index];
  //Jmeno otce a matky
  if Cells[id,index]=Cells[otec,ARow] then
    Lotec.Caption:= indexInfo;
  if Cells[id,index]=Cells[matka,ARow] then
    Lmatka.Caption:= indexInfo;

  //Deti a manzel(ka)
   if (Cells[otec,index] = Aid) then //
     begin
      deti.Items.Add( indexInfo );  //Proda dite
      if Cells[matka,index]<>'' then //Prida manzela(ku) pokud je
       begin
        manzelInfo:=Cells[matka,index];
        manzelInfo:=manzelInfo +' - '+ Cells[jmeno, Cols[0].IndexOf(manzelInfo)]+ ' '+ Cells[prijmeni, Cols[0].IndexOf(manzelInfo)];

        if manzel.Items.IndexOf( manzelInfo )=-1 then //Aby nebyl stejnty clovek 2x v seznamu
          manzel.items.add( manzelInfo );
       end;
     end;
   if (Cells[matka,index] = Aid) then
     begin
      deti.Items.Add( indexInfo );
      if Cells[otec,index]<>'' then
       begin
        manzelInfo:=Cells[otec,index];
        manzelInfo:=manzelInfo +' - '+ Cells[jmeno, Cols[0].IndexOf(manzelInfo)]+ ' '+ Cells[prijmeni, Cols[0].IndexOf(manzelInfo)];

        if manzel.Items.IndexOf( manzelInfo )=-1 then //Aby nebyl stejnty clovek 2x v seznamu
        manzel.items.add( manzelInfo );
       end;
     end;

  end;//for end

  end;//with end
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if SaveDialog1.Execute then
   UlozRodokmen(SaveDialog1.FileName);
end;

procedure TForm1.Button3Click(Sender: TObject);
//Prida novou kolonku
var noveID: String;
    noveIDcislo: Integer;
begin
 Tabulka.RowCount:= Tabulka.RowCount+1;

 noveIDcislo:= 1;
 while Tabulka.Cols[0].IndexOf('I'+ IntToStr(noveIDcislo))<>-1 do
   Inc(noveIDcislo);

 Tabulka.Cells[0,Tabulka.RowCount-1]:='I'+ IntToStr(noveIDcislo);


end;

procedure TForm1.Button4Click(Sender: TObject);
//Smazani vybrane osoby
var index: Integer;
    Aid: String; //ID mazane osoby
begin
 if Tabulka.RowCount<=2 then
   begin
    Application.MessageBox('Posledn poloku nelze smazat','Pozor',0);
    exit;
   end;
 Aid:= Tabulka.Cells[ id, Tabulka.Row];

 for index:= Tabulka.Row to Tabulka.RowCount do
    Tabulka.Rows[index]:=Tabulka.Rows[index+1];

 Tabulka.RowCount:= Tabulka.RowCount-1;

//Je potreba jeste smazat vsechny odkazy na smazanou osobu
  for index:=1 to Tabulka.RowCount do
   begin
    if Tabulka.Cells[otec,index] = Aid then Tabulka.Cells[otec,index]:='';
    if Tabulka.Cells[matka,index] = Aid then Tabulka.Cells[matka,index]:='';
   end;

end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
  begin
   PridejRodokmen(OpenDialog1.FileName);
  end;
end;

end.








